Index: drivers/net/ax88796b-ts7370.c
===================================================================
RCS file: /cvsroot/ts-7800/dist/linux-2.6.21-ts/drivers/net/ax88796b-ts7370.c,v
retrieving revision 1.6
diff -u -r1.6 ax88796b-ts7370.c
--- drivers/net/ax88796b-ts7370.c	21 Aug 2008 22:46:12 -0000	1.6
+++ drivers/net/ax88796b-ts7370.c	21 Sep 2011 16:40:40 -0000
@@ -480,12 +480,14 @@
         {
 
 		adaux = (void *)ioremap(0x80010050, 0xFF);
-                SA_prom[0] = inb(adaux+0x0);
-                SA_prom[1] = inb(adaux+0x1);
-                SA_prom[2] = inb(adaux+0x2);
-                SA_prom[3] = inb(adaux+0x3);
-                SA_prom[4] = inb(adaux+0x4);
                 SA_prom[5] = inb(adaux+0x5) + 0x1;
+                SA_prom[4] = inb(adaux+0x4);
+		if(0x0 == SA_prom[5]) SA_prom[4]++;
+                SA_prom[3] = inb(adaux+0x3);
+		if(0x0 == SA_prom[4]) SA_prom[3]++;
+                SA_prom[2] = inb(adaux+0x2);
+                SA_prom[1] = inb(adaux+0x1);
+                SA_prom[0] = inb(adaux+0x0);
 		iounmap(adaux);
         }
 #endif
